//////////////////////////////////////////////////////////////////////////////
//                      OVLADANI HRACE KLAVESNICI                           //
//                      ~~~~~~~~~~~~~~~~~~~~~~~~~                           //
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <assert.h>

//#include "losa.h"
//#include "xvga.h"
#include "pal.h"

#define SPR_FNAME "spr"
#define OPP_FNAME "opp"
#define PAN_FNAME "pan"
#define MAS_FNAME "mas"
#define PRI_FNAME "kpri"
#define MAP_FNAME "map"
#define SOU_FNAME "sou"
#define SSV_FNAME "ssv"
#define PAL_FNAME "pal"
#define MFR_FNAME "mfr"
#define FRE_FNAME "fre"
#define VFR_FNAME "vfr"
#define MSK_FNAME "msk"

#define PAK_FEXT ".pak"
#define SPR_FEXT ".spr"
#define PRI_FEXT ".pri"
#define MAP_FEXT ".map"
#define SOU_FEXT ".sou"
#define PAL_FEXT ".pal"
#define CFG_FEXT ".cfg"

#define ERR_OPEN  1
#define ERR_READ  2
#define ERR_CLOSE 3
#define ERR_ALLOC 4
#define ERR_FREE  5
#define ERR_SPRF  6
#define ERR_WRITE 7

#define XY_VGA   16
#define SPR_VGA  256

 FILE *F;

//////////////////////////////////////////////////////////////////////////////
//                           LOADOVACI RUTINY                               //
//                           ~~~~~~~~~~~~~~~~                               //
//////////////////////////////////////////////////////////////////////////////

  char FPath [80];
  char Cesta [30] = "SKY\\";
  char LevBuf [4];
  short PAK_Handle;

  struct
  {
    unsigned char X_SIZ;
    unsigned char Y_SIZ;
    short COUNT;
  } SPRH;

  struct Priznaky
  {
    unsigned char HLPR, VLPR;
  };

  struct Souradnice                  /* Pouzito pro ovladani dveri            */
  {                             /* CX,CY - souradnice tlacitka(pocitace) */
    unsigned char CX,CY,DX,DY;  /* DX,DY - souradnice dveri              */
  };

  struct OppS
  {
    unsigned char SX,SY;
    short FRM;
  };

  struct Priznaky   priz[1000];
  struct Souradnice psou[256];
  struct OppS       Opp [256];

  char ZPAL[768];

///// LOAD & SAVE MAP

int ReadMAP (short Level, char *Name, short *MAP, int SizeXY)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, Name);
  strcat (FPath, LevBuf);
  strcat (FPath,MAP_FEXT);
  F= fopen (FPath,"rb");
  if (F == NULL)
  {
    return (ERR_OPEN);
  }

  if (fread (MAP,2,SizeXY,F)!=SizeXY)
  {
    return (ERR_READ);
  }

  if (fclose (F) != 0)
  {
    return (ERR_CLOSE);
  }

  return 0;
}
/*
int WriteMAP (short Level, char *Name, short *MAP, int SizeXY)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, Name);
  strcat (FPath, LevBuf);
  strcat (FPath,MAP_FEXT);
  F= fopen (FPath,"wb");
  if (F == NULL)
  {
    Return (ERR_OPEN);
  }

  if (fwrite (MAP, 1, SizeXY*2, F) != SizeXY*2)
  {
    Error (ERR_WRITE, FPath);
  }

  if (fclose (F) != 0)
  {
    Error (ERR_CLOSE, FPath);
  }
}
*/
///// LOAD & SAVE LIGHTs MAP ( mask map of lights)

int ReadMSK (short Level, char *Name, char *MSK, int SizeXY)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, Name);
  strcat (FPath, LevBuf);
  strcat (FPath,MAP_FEXT);
  F= fopen (FPath,"rb");
  if (F == NULL)
  {
    return (ERR_OPEN);
  }

  if (fread (MSK,1,SizeXY,F)!=SizeXY)
  {
    return (ERR_READ);
  }

  if (fclose (F) != 0)
  {
    return (ERR_CLOSE);
  }

  return 0;
}
/*
int WriteMSK (short Level)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, MSK_FNAME);
  strcat (FPath, LevBuf);
  strcat (FPath,MAP_FEXT);
  F= fopen (FPath,"wb");
  if (F == NULL)
  {
    Error (ERR_OPEN, FPath);
  }

  if (fwrite (MSK, 1, 255*255, F) != 255*255)
  {
    Error (ERR_WRITE, FPath);
  }

  if (fclose (F) != 0)
  {
    Error (ERR_CLOSE, FPath);
  }
}
*/
///// LOAD & SAVE SPRITES

int ReadSPR (short Level, char *Name, char *PNT, int siz, int limit)
{
  unsigned char *zas;
  int i;

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, Name);
  strcat (FPath, LevBuf);
  strcat (FPath,SPR_FEXT);
  F = fopen (FPath,"rb");
  if (F == NULL)
  {
    return (ERR_OPEN);
  }
  if (fread (&SPRH.X_SIZ, 1, 4, F) != 4)
  {
    return (ERR_READ);
  }

 if ((SPRH.X_SIZ != siz) || (SPRH.Y_SIZ != siz))
  {
    return (ERR_SPRF);
  }

  if (limit < SPRH.COUNT)
    SPRH.COUNT = limit;

  if (fread (PNT, 1, (unsigned)(siz*siz*SPRH.COUNT), F) != (unsigned)(siz*siz*SPRH.COUNT))
      {
        return (ERR_READ);
      }
  if (fclose (F) != 0)
  {
    return (ERR_CLOSE);
  }

  return 0;
}

///// LOAD & SAVE KOSTICKA PRIZNAKU

int ReadPRI(short Level)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath,Cesta);
  strcat (FPath,PRI_FNAME);
  strcat (FPath,LevBuf);
  strcat (FPath,PRI_FEXT);
  F=fopen (FPath,"rb");

  if (F==NULL)
  {
     return (ERR_OPEN);
  }

  if (fread (&priz, 1, 2000, F)!=2000)
  {    return (ERR_READ);
  }

  if (fclose (F) != 0)
  {
    return (ERR_CLOSE);
  }

  return 0;
}

/*
int WritePRI(short Level)
{
  sprintf (LevBuf, "%i", Level);
  strcpy (FPath, Cesta);
  strcat (FPath, PRI_FNAME);
  strcat (FPath, LevBuf);
  strcat (FPath,PRI_FEXT);
  F= fopen (FPath,"wb");
  if (F == NULL)
  {
    Error (ERR_OPEN, FPath);
  }

  if (fwrite (&priz, 1, 2000, F) != 2000)
  {
    Error (ERR_WRITE, FPath);
  }

  if (fclose (F) != 0)
  {
    Error (ERR_CLOSE, FPath);
  }
}
///// LOAD & SAVE COORDINATES OF DOORS & SWITCHES

int ReadSOU(short Level)
{

  sprintf (LevBuf, "%i", Level);
  strcpy (FPath,Cesta);
  strcat (FPath,SOU_FNAME);
  strcat (FPath,LevBuf);
  strcat (FPath,SOU_FEXT);

  F=fopen (FPath,"rb");
  if (F==NULL)
  {
     Error (ERR_OPEN, FPath);
  }

  if (fread (&psou, 1, 1024, F)!=1024)
  {
    Error (ERR_READ, FPath);
  }

  fclose (F);
}

///// LOAD COLOR PALLETE
*/

void Palcpy (TRGBColor *PAL1, char *PAL2)
{
  short i;

  for (i=0; i<256; i++)
  {
    PAL1[i].r=PAL2[i*3] *4;
    PAL1[i].g=PAL2[i*3+1] *4;
    PAL1[i].b=PAL2[i*3+2] *4;
    PAL1[i].a=0;
  }
}


int ReadPAL(short Level, char *Name, TRGBColor *PAL, int Size)
{
  sprintf (LevBuf, "%i", Level);
  strcpy (FPath,Cesta);
  strcat (FPath,Name);
  strcat (FPath,LevBuf);
  strcat (FPath,PAL_FEXT);

  F=fopen (FPath,"rb");
  if (F==NULL)
  {
     return (ERR_OPEN);
  }

  if (fread (ZPAL, 1, Size, F)!=Size)
  {
    return (ERR_READ);
  }

  PAL_PAL2RGB (PAL, ZPAL, 256);
  fclose (F);

  return 0;
}

