
#include <mem.h>
#include <stdio.h>

#include "cgdk.h"
#include "pal.h"
#include "svga.h"
#include "stars.h"
#include "keyb.h"
#include "timer.h"

int main (void)
{
  TRGBColor pal [256];
  int i;
  int videoMode;
  int numstars;

  printf ("\n"
          "STARS - example of the CGDK stars engine\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();
  TIMER_init (TIMER_OLDFREQ_DEF);

  KEYB_init ();

  for (i = 0; i <= 255; i++)
  {
    pal [i].r = pal [i].b = pal [i].g = i;
  }

  videoMode = SVGA_recommendVideoMode (640, 400, 1, VMODE_LINEAR);
  if (videoMode)
  {
    numstars = 380;

    SVGA_setVideoMode (videoMode);
    PAL_set (pal, 0, 256);

    STARS_init (SVGA_linearBuf, SVGA_virtualX, SVGA_maxY, numstars);
    STARS_setColors (1, 255);
    STARS_setSpeed (15);
    STARS_setZoom (256);
    STARS_setDistance (5000);

    while (KEYB_get () != KEY_ESC)
    {
      SVGA_wait (1);
      STARS_update ();
    }

    PAL_fadeOut (pal, 75, 0, 256);

    return 0;
  }
  else
  {
    printf ("Program requires at least a VGA compatible videocard.\n");
    return 1;
  }
}
